/*
|	Scorch.C by Lionel Baboud
|	The Casio Site: http://perso.wanadoo.fr/duobab/
|	e-mail: roland.baboud@wanadoo.fr
|	------------------------------
|	compiled with TurboC 2.01 and TASM 4.1 ("tcc -1 -mt scorch.c")
|
|	Controls:
|	---------
|	- [up]/[down] : increase/decrease the shoot power
|	- [left]/[right] : change the cannon angle
|	- [EXE] : shoot (during game) and buy a weapon (in the market menu)
|	- [F1]/[F2] : change weapon 
|	- [I] : weapon inventory
|	- [CTRL] : toggle offensive/defensive mode
|	- [B] : use 1 battery
|	- [F] : use fuel to move the tank
|	- [->] : pass your turn in the weapon market menu
|	- [ESC] : exit match/game
*/

#include <conio.h>
#include <math.h>
#include <dos.h>
#define SEG1 0x1A20
#define SEG2 0x1A60
#define EXE	28
#define ESC	1
#define CTRL	29
#define NEXT	76
#define PMAX	6	/*nombre de joueurs maximum*/
#define AMAX1	13	/*nombre d'armes offensives*/
#define AMAX	16	/*nombre d'armes au total*/
#define TMAX	10	/* traine des tirs*/
#define RMAX	6	/* roller */
#define NMAX	100	/* napalm */
#define FMAX	8	/* funky bomb */
#define MFMAX	8	/* max( FunkyMAX , MirvMAX ) */
#define kup	72
#define kdown	80
#define kright	77
#define kleft	75
#define NEWROUND	130
#define PLAY	120
#define CHECKTANKS	160
#define ENDTURN	140
#define MENU	150


int sol[128];
int tankx[PMAX];
int tanky[PMAX];
int angle[PMAX];
int power[PMAX];
int w;		/* w = force du vent / masse */
int g=100;	/* pesanteur */
double dt=0.005;
double wdt2;
double gdt2;
int wmax=50;
int mmax=5;
int mcur;
int p,q;
char noms[PMAX][6];
int bat[PMAX];
int credits[PMAX];
long fricdeb=0;
long fric[PMAX];
int stock[PMAX][AMAX];
int dispo[AMAX];
int dispomax=0;
int asel[PMAX];
double v[2];
double om[2];
int pt[TMAX][2];
int ptx[MFMAX][TMAX];
int pty[MFMAX][TMAX];
int explx[MFMAX],exply[MFMAX];
int a,b;
int stop;
int ordre[PMAX];
int taux=25;
int barreMode;
int hv=15;
int bump=0;
int NP=2;

char armesNoms[][13]={	"BABY MISSILE",
					"MISSILE     ",
					"BABY NUKE   ",
					"NUKE        ",
					"ROLLER      ",
					"MIRV        ",
					"LEAPFROG    ",
					"RIOT BOMB   ",
					"RIOT CHARGE ",
					"NAPALM      ",
					"FUNKY BOMB  ",
					"DIGGER      ",
					"SANDHOG     ",
					"BATTERY     ",
					"PARACHUTES  ",
					"FUEL TANK   "};
int armesRay[]={3,4,9,15,5,4,8,8,7,50,4,500,500,100,0,5};
int armesPrix[]={15,150,780,1260,330,590,580,200,80,430,400,100,680,510,490,810};
int armesLots[]={10,5,3,1,5,3,2,5,10,10,2,5,5,10,8,10};

int paraPic[][22]= {{-2, 0, 2,-3, 0, 3,-4,-3,-2,-1, 0, 1, 2, 3, 4,-3,-2,-1, 0, 1, 2, 3},
				{ 2, 2, 2, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5}};
int paraPix[22];

char listePics[AMAX][80];

char alpha[][5][4]=
   {{{1,1,1,1},		/*0*/
	{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1},
	{1,1,1,1}},

    {{0,0,1,0},
	{0,0,1,0},
	{0,0,1,0},
	{0,0,1,0},
	{0,0,1,0}},

    {{1,1,1,1},
	{0,0,0,1},
	{1,1,1,1},
	{1,0,0,0},
	{1,1,1,1}},

    {{1,1,1,1},
	{0,0,0,1},
	{0,1,1,1},
	{0,0,0,1},
	{1,1,1,1}},

    {{1,0,0,0},
	{1,0,0,0},
	{1,0,1,0},
	{1,1,1,1},
	{0,0,1,0}},

    {{1,1,1,1},
	{1,0,0,0},
	{1,1,1,1},
	{0,0,0,1},
	{1,1,1,1}},

    {{1,1,1,1},
	{1,0,0,0},
	{1,1,1,1},
	{1,0,0,1},
	{1,1,1,1}},

    {{1,1,1,1},
	{0,0,0,1},
	{0,0,1,0},
	{0,1,0,0},
	{0,1,0,0}},

    {{1,1,1,1},
	{1,0,0,1},
	{1,1,1,1},
	{1,0,0,1},
	{1,1,1,1}},

    {{1,1,1,1},
	{1,0,0,1},
	{1,1,1,1},
	{0,0,0,1},
	{1,1,1,1}},

    {{0,1,1,0},		/*10*/
	{1,0,0,1},
	{1,0,0,1},
	{1,1,1,1},
	{1,0,0,1}},

    {{1,1,1,0},
	{1,0,0,1},
	{1,1,1,0},
	{1,0,0,1},
	{1,1,1,0}},

    {{0,1,1,0},
	{1,0,0,1},
	{1,0,0,0},
	{1,0,0,1},
	{0,1,1,0}},

    {{1,1,1,0},
	{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1},
	{1,1,1,0}},

    {{1,1,1,1},
	{1,0,0,0},
	{1,1,1,0},
	{1,0,0,0},
	{1,1,1,1}},

    {{1,1,1,1},
	{1,0,0,0},
	{1,1,1,0},
	{1,0,0,0},
	{1,0,0,0}},

    {{0,1,1,1},
	{1,0,0,0},
	{1,0,1,1},
	{1,0,0,1},
	{0,1,1,1}},

    {{1,0,0,1},
	{1,0,0,1},
	{1,1,1,1},
	{1,0,0,1},
	{1,0,0,1}},

    {{0,1,1,1},
	{0,0,1,0},
	{0,0,1,0},
	{0,0,1,0},
	{0,1,1,1}},

    {{1,1,1,1},
	{0,0,0,1},
	{0,0,0,1},
	{1,0,0,1},
	{0,1,1,0}},

    {{1,0,0,1},		/*20*/
	{1,0,1,0},
	{1,1,0,0},
	{1,0,1,0},
	{1,0,0,1}},

    {{1,0,0,0},
	{1,0,0,0},
	{1,0,0,0},
	{1,0,0,0},
	{1,1,1,1}},

    {{1,0,0,1},
	{1,1,1,1},
	{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1}},

    {{1,0,0,1},
	{1,1,0,1},
	{1,0,1,1},
	{1,0,0,1},
	{1,0,0,1}},

    {{0,1,1,0},
	{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1},
	{0,1,1,0}},

    {{1,1,1,0},
	{1,0,0,1},
	{1,0,0,1},
	{1,1,1,0},
	{1,0,0,0}},

    {{0,1,1,0},
	{1,0,0,1},
	{1,0,0,1},
	{1,0,1,0},
	{0,1,0,1}},

    {{1,1,1,0},
	{1,0,0,1},
	{1,1,1,0},
	{1,0,0,1},
	{1,0,0,1}},

    {{0,1,1,1},
	{1,0,0,0},
	{0,1,1,0},
	{0,0,0,1},
	{1,1,1,0}},

    {{1,1,1,1},
	{0,1,0,0},
	{0,1,0,0},
	{0,1,0,0},
	{0,1,0,0}},

    {{1,0,0,1},		/*30*/
	{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1},
	{0,1,1,0}},

    {{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1},
	{1,0,1,0},
	{0,1,0,0}},

    {{1,0,0,1},
	{1,0,0,1},
	{1,0,0,1},
	{1,0,1,1},
	{1,0,0,1}},

    {{1,0,0,1},
	{1,0,0,1},
	{0,1,1,0},
	{1,0,0,1},
	{1,0,0,1}},

    {{1,0,0,1},
	{1,0,0,1},
	{0,1,1,1},
	{0,0,0,1},
	{0,1,1,0}},

    {{1,1,1,1},
	{0,0,1,0},
	{0,1,0,0},
	{1,0,0,0},
	{1,1,1,1}},

    {{0,0,0,0},		/*36*/
	{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0}},

    {{0,0,0,1},
	{0,0,1,1},
	{0,1,1,1},
	{0,0,1,1},
	{0,0,0,1}},

    {{1,0,0,0},
	{1,1,0,0},
	{1,1,1,0},
	{1,1,0,0},
	{1,0,0,0}},

    {{0,1,1,0},
	{0,1,0,0},
	{0,1,0,0},
	{0,1,0,0},
	{0,1,1,0}},

    {{0,1,1,0},
	{0,0,1,0},
	{0,0,1,0},
	{0,0,1,0},
	{0,1,1,0}},

    {{0,0,0,0},
	{0,1,0,0},
	{0,0,0,0},
	{0,1,0,0},
	{0,0,0,0}},

    {{0,0,0,0},		/*42*/
	{0,0,0,0},
	{0,1,1,1},
	{0,0,0,0},
	{0,0,0,0}},

    {{0,1,1,0},
	{1,0,0,1},
	{0,0,1,0},
	{0,0,0,0},
	{0,1,0,0}},

    {{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0},
	{0,1,0,0}},

    {{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0},
	{0,0,0,0}}};

char fleche[][7][5]=
   {{{0,0,1,0,0},
	{0,1,1,1,0},
	{1,1,1,1,1},
	{0,0,1,0,0},
	{0,0,1,0,0},
	{0,0,1,0,0},
	{0,0,1,0,0}},

    {{0,0,1,0,0},
	{0,0,1,0,0},
	{0,0,1,0,0},
	{0,0,1,0,0},
	{1,1,1,1,1},
	{0,1,1,1,0},
	{0,0,1,0,0}}};

char armesPic[][5][14]=
   {{{0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,1,1,1,1,1,0,0,0,0,0,0,0},
	{0,0,0,0,1,1,1,1,1,1,1,1,0,0},
	{0,0,1,1,1,1,1,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0}},

    {{0,1,1,1,1,0,0,0,0,0,0,0,0,0},
	{0,0,1,1,1,1,1,1,1,1,1,0,0,0},
	{0,0,1,1,1,1,1,1,1,1,1,1,1,0},
	{0,0,1,1,1,1,1,1,1,1,1,0,0,0},
	{0,1,1,1,1,0,0,0,0,0,0,0,0,0}},

    {{0,1,1,1,1,0,0,0,1,0,1,1,0,0},
	{0,0,1,1,1,1,1,1,1,0,1,1,1,0},
	{0,0,1,1,1,1,1,1,1,0,1,1,1,0},
	{0,0,1,1,1,1,1,1,1,0,1,1,1,0},
	{0,1,1,1,1,0,0,0,1,0,1,1,0,0}},

    {{1,1,1,1,0,0,0,0,1,0,1,1,1,0},
	{0,1,1,1,1,1,1,1,1,0,1,1,1,1},
	{0,0,1,1,1,1,1,1,1,0,1,1,1,1},
	{0,1,1,1,1,1,1,1,1,0,1,1,1,1},
	{1,1,1,1,0,0,0,0,1,0,1,1,1,0}},

    {{0,0,0,0,1,1,1,1,1,1,0,0,0,0},
	{0,0,0,1,0,0,0,0,0,0,1,0,0,0},
	{0,0,0,1,0,1,1,1,1,0,0,1,0,0},
	{0,0,0,1,0,0,0,0,0,1,0,1,0,0},
	{0,0,0,0,1,1,1,1,1,0,0,1,0,0}},

    {{0,0,0,0,0,0,1,0,0,0,0,0,0,0},
	{0,0,0,0,1,1,1,1,1,0,0,0,0,0},
	{0,0,0,1,0,0,1,0,0,1,0,0,0,0},
	{0,0,1,0,0,0,1,0,0,0,1,0,0,0},
	{0,0,1,0,0,0,1,0,0,0,1,0,0,0}},

    {{0,1,1,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,1,0,0,0,1,1,0,0,0,0,0},
	{0,0,0,0,1,0,1,0,0,1,0,1,1,0},
	{0,0,0,0,0,1,0,0,0,0,1,0,0,0},
	{0,0,0,0,0,1,0,0,0,0,1,0,0,0}},

    {{0,0,0,0,0,0,0,0,0,1,1,1,1,1},
	{0,0,0,0,1,1,0,0,0,0,1,1,1,1},
	{0,0,1,1,1,1,0,0,0,0,1,1,1,1},
	{1,1,1,1,1,1,1,0,0,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1}},

    {{1,1,1,1,1,0,0,0,0,0,0,0,0,0},
	{1,1,1,1,1,1,0,0,0,0,0,0,0,0},
	{1,1,1,1,0,0,0,0,0,1,1,0,0,0},
	{1,1,1,0,0,1,1,1,0,0,1,1,1,0},
	{1,1,1,0,1,1,1,1,1,0,1,1,1,1}},

    {{1,0,0,0,0,0,0,0,0,0,0,0,0,1},
	{1,0,1,0,1,0,1,0,1,0,1,0,1,1},
	{1,1,0,1,0,1,0,1,0,1,0,1,1,1},
	{1,1,1,1,1,0,1,0,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1}},

    {{0,0,1,0,0,0,0,0,0,0,1,0,0,0},
	{0,0,0,0,0,0,1,0,0,0,0,0,0,0},
	{0,0,0,0,0,1,1,1,0,0,0,0,0,0},
	{0,0,0,0,0,0,1,0,0,0,0,0,0,0},
	{0,0,1,0,0,0,0,0,0,0,1,0,0,0}},

    {{1,1,1,1,1,1,0,1,1,1,1,1,1,1},
	{1,1,0,0,1,0,0,0,0,0,1,0,0,1},
	{1,1,1,0,0,0,0,1,0,0,0,0,0,1},
	{1,1,0,0,0,0,1,1,0,0,0,0,1,1},
	{1,1,1,0,1,1,1,1,1,0,1,1,1,1}},

    {{0,1,1,1,1,0,1,1,1,1,1,0,1,1},
	{1,0,1,1,0,1,0,1,1,1,0,1,1,1},
	{1,1,0,0,1,1,1,0,1,0,1,0,1,1},
	{1,1,0,0,1,1,1,1,0,1,1,1,0,1},
	{1,1,1,1,0,1,1,0,1,1,1,1,1,1}},

    {{0,1,1,1,1,1,1,1,1,1,1,0,0,0},
	{0,1,1,1,1,1,1,1,0,1,1,1,0,0},
	{0,1,0,0,0,1,1,0,0,0,1,1,0,0},
	{0,1,1,1,1,1,1,1,0,1,1,1,0,0},
	{0,1,1,1,1,1,1,1,1,1,1,0,0,0}},

    {{0,0,1,1,1,1,1,1,1,1,1,0,0,0},
	{0,1,1,1,1,1,1,1,1,1,1,1,0,0},
	{0,1,1,0,0,0,1,0,0,0,1,1,0,0},
	{0,0,0,1,0,0,1,0,0,1,0,0,0,0},
	{0,0,0,0,1,0,1,0,1,0,0,0,0,0}},

    {{0,0,0,1,1,1,0,0,0,1,0,0,0,0},
	{0,0,0,1,0,1,0,0,0,1,0,0,0,0},
	{0,0,0,1,0,1,1,1,1,1,0,0,0,0},
	{0,0,0,0,0,1,1,1,1,1,0,0,0,0},
	{0,0,0,0,0,1,1,1,1,1,0,0,0,0}}};

unsigned char barre[][128]=
   {{0,0,0,0,0,0,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	4,4,4,4,4,4,4,0xFF,
	0,0x40,0x40,0x80,0,0x80,0,0xFF,
	8,8,8,0xA,0xB,0xB,8,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0x80,0xC0,0xC0,0xC0,0x80,0,0xFF,
	0x80,0xAB,0x97,0xAF,0x97,0xAB,0x80,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0xFC,0xFC,0xC4,0xFC,0x38,0,0xFF,
	0x20,0x2F,0x2D,0x28,0x2D,0x27,0x20,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0,0,0,0,0,0,0xFF},

	{0,8,0x7C,0x7E,0x7C,8,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0x10,0x3E,0x7E,0x3E,0x10,0,0xFF,
	1,0x7D,0x7D,0x7D,0x45,0xC5,1,0xFF,
	0,0,1,1,1,1,0,0xFF,
	0x10,0x10,0x10,0x90,0xD0,0x90,0x10,0xFF,
	0,0xE,0x15,0x24,0x7F,0x3F,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	4,0xE4,0x74,0x34,0x74,0xE4,4,0xFF,
	0,0x7F,0x7F,0x46,0x7F,0x7F,0,0xFF,
	0,0,0,0,0,0,0,0xFF,
	4,4,4,4,4,4,4,0xFF,
	0,0,0,0,0,0,0,0xFF,
	0,0xC0,0x60,0x20,0x60,0xC0,0,0xFF,
	0,0x7F,0x7F,0x46,0x7F,0x39,0,0xFF}};
     
unsigned char intro[] =
	{255,255,255,255,255,255,255,255,255,255,255,255,127,127,63,31,
	31,15,7,3,1,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	224,248,252,252,126,62,126,254,254,254,254,252,252,248,224,0,
	255,255,255,255,255,255,255,255,131,1,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,255,255,0,73,0,1,15,223,239,247,255,255,255,0,
	255,255,255,255,255,255,255,255,255,254,252,252,248,248,240,224,
	192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,255,255,248,242,248,252,254,255,255,255,255,255,255,0,
	255,255,63,191,223,223,63,255,255,255,255,255,255,255,255,255,
	255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,31,31,31,31,31,31,31,31,31,31,31,255,255,0,
	255,176,23,119,119,241,246,246,241,255,255,255,255,31,7,3,
	0,0,0,0,0,0,0,0,0,136,8,8,8,0,190,0,
	0,0,208,16,30,1,1,30,0,0,0,0,0,0,0,0,
	255,255,143,143,143,143,128,128,128,143,143,143,143,255,255,0,
	255,239,48,183,211,218,56,252,253,255,255,255,0,0,0,0,
	0,0,0,0,0,0,0,0,0,139,137,81,33,81,139,0,
	0,0,251,130,130,226,2,250,0,0,0,0,0,0,0,0,
	255,255,225,128,0,31,63,63,63,31,0,128,225,255,255,0,
	255,240,247,119,183,145,214,214,17,255,255,255,252,0,0,0,
	0,0,0,0,0,0,0,0,0,62,32,32,60,0,62,0,
	0,0,34,34,34,62,34,34,0,0,0,0,0,0,0,0,
	255,255,227,195,135,14,30,30,142,142,15,31,63,255,255,0,
	255,81,150,215,211,219,221,222,223,255,255,255,255,254,248,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,199,199,199,64,64,71,71,71,192,192,192,255,255,0,
	255,124,157,237,229,245,245,117,141,255,255,255,255,63,15,0,
	0,0,0,0,0,0,0,0,0,0,0,192,32,32,192,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,3,1,0,120,252,252,252,120,0,1,3,255,255,0,
	255,254,254,254,254,254,254,254,126,255,63,7,0,0,0,0,
	0,0,0,0,0,0,0,0,0,114,138,139,136,136,139,0,
	0,0,68,68,68,74,81,145,0,0,0,0,0,0,0,0,
	255,255,31,14,12,248,248,248,248,248,12,14,31,255,255,0,
	255,247,247,247,247,227,221,190,127,255,254,240,0,0,0,0,
	0,0,0,0,0,0,0,0,0,136,8,8,8,0,190,0,
	0,0,244,132,133,132,132,131,0,0,0,0,0,0,0,0,
	255,255,254,248,112,97,99,227,227,225,48,56,126,255,255,0,
	255,135,185,189,190,142,177,183,143,255,255,255,255,252,128,0,
	0,0,0,0,0,0,0,0,0,207,40,40,207,0,239,0,
	0,0,32,32,60,2,2,60,0,0,0,0,0,0,0,0,
	255,255,131,0,0,248,240,192,131,135,128,192,240,255,255,0,
	255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,
	124,0,0,0,0,0,0,0,0,3,0,0,1,2,1,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,
	255,255,255,255,255,255,255,255,255,255,127,63,31,15,3,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,255,255,63,159,63,127,255,255,255,255,255,255,255,0,
	255,255,255,255,255,255,143,3,1,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	255,255,255,255,0,36,0,0,224,247,239,223,255,255,255,0,
	255,255,255,255,255,255,255,255,254,254,252,252,248,248,240,240,
	224,192,128,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	7,31,63,63,124,121,124,127,127,127,127,63,63,31,7,0};


			
			/*******************************************************/ 
			/*				fonctions d'affichage			*/ 
			/*******************************************************/
#define LBL(a) } a: asm {
  void __cdecl gotoxy(int x,int y);

   int CASIO=1;

  

void drawPict(unsigned char map[],unsigned int segm)
	{asm push es;
	asm push ds;
	asm push si;
	asm push di;

	asm mov ax,segm;
	asm mov es,ax;
	asm mov di,0;
	asm mov si,map;
	asm cld;
	asm mov cx,512;
	asm rep movsw;

	asm pop di;
	asm pop si;
	asm pop ds;
	asm pop es;}
	
void copyScreen(unsigned int orig,unsigned int dest)
	{asm push es;
	asm push ds;
	asm push si;
	asm push di;

	asm mov ax,dest;
	asm mov es,ax;
	asm mov di,0;
	asm mov ax,orig;
	asm mov ds,ax;
	asm mov si,0;
	asm cld;
	asm mov cx,512;
	asm rep movsw;

	asm pop di;
	asm pop si;
	asm pop ds;
	asm pop es;}
	
int delay(unsigned int hs) /*{long i;
	for (i=0; i<=hs*100;i--) i+= 1;} */
{
     struct time before, after;
     unsigned int buf;
     hs=(hs-(hs%10))/10;


     gettime(&before);
     do
     {
     gettime(&after);
     buf=(after.ti_hund + (after.ti_sec + after.ti_min * 60) * 100)
         - (before.ti_hund + (before.ti_sec + before.ti_min * 60) * 100);
     if ((hs - buf) > 6 )
     {
         asm {
         //hlt;
         hlt;//makes the cpu waits for any interruption
         }
     }
     } while (buf < hs);

     return buf;
}

void clrScreen(unsigned int dest)
	{asm push es;
	asm push ds;
	asm push si;
	asm push di;

	asm mov ax,dest;
	asm mov es,ax;
	asm mov di,0;
	asm mov al,0;
	asm cld;
	asm mov cx,1024;
	asm rep stosb;

	asm pop di;
	asm pop si;
	asm pop ds;
	asm pop es;}

void clrHLine(int y,unsigned int seg)  /* ligne haut=0, ligne bas=63  */
	{ short page;
          int i,i0=63-y;
          if(seg==SEG1) page=0;
	else if(seg==SEG2) page=1;
	for(i=i0;i<i0+1024;i+=64)
		{asm push es;asm push di;

		asm mov ax,page;
                asm shl ax,6;
                asm add ax,0x1A20;
                asm mov es,ax;
		asm mov di,i;
		asm mov al,0;
		asm mov es:[di],al;

		asm pop di;asm pop es;
		}
	}

void invHLine(int y,unsigned int seg)  /* ligne haut=0, ligne bas=63  */
	{ short page;
          int i,j=63-y;
          if(seg==SEG1) page=0;
	else if(seg==SEG2) page=1;
	for(i=j;i<j+1024;i+=64)
		{asm push es;asm push di;

		asm mov ax,page;
                asm shl ax,6;
                asm add ax,0x1A20;
                asm mov es,ax;
		asm mov di,i;
		asm mov al,es:[di];
		asm not al;
		asm mov es:[di],al;

		asm pop di;asm pop es;}
	}

void invMenuLine(int c)  /* ligne haut=0, ligne bas=3  */
	{int i,j,k=63-(23+9*(c%2)),l=192+320*(1-(c/2));
	for(i=k+l;i<k+320+l;i+=64)
	  for(j=i;j>i-8;j--)
		{asm push es;asm push di;

		asm mov ax,SEG1;
		asm mov es,ax;
		asm mov di,j;
		asm mov al,es:[di];
		asm not al;
		asm mov es:[di],al;

		asm pop di;asm pop es;}
	}

void invTxtLine(int y)
	{int i;
	for (i=8*y;i<8*(y+1);i++)
		invHLine(i,SEG1);
	}

void invAlphaLine(int y)
	{int i;
	for (i=y;i<y+7;i++)
		invHLine(i,SEG1);
		

	}
	
	void exit(int c)
{
 asm mov ax, 0x4C00;
asm int 0x21;
}
void setPix(unsigned short int x, unsigned short int y,unsigned int segm,char state)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov es,segm;
	asm mov al,state;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm and es:[si],ah;
	asm mov ah,al;
	asm rol ah,cl;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}
void invPix(unsigned short int x, unsigned short int y,unsigned int segm)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov es,segm;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm mov al,1;
	asm rol al,cl;
	asm and al,es:[si];
	asm and es:[si],ah;
	asm not ah;
	asm xor ah,al;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}

        char getPix(unsigned short int x, unsigned short int y,unsigned int segm)
	{unsigned char state=1;
	asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov es,segm;
	asm mov al,state;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,es:[si];
	asm ror ah,cl;
	asm and state,ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;
	return state;}

void hline(int x1,int x2,int y)
	{int i;
	for(i=x1;i<=x2;i++) setPix(i,y,SEG1,1);}

/*void hlineOff(int x1,int x2,int y)
	{int i;
	for(i=x1;i<=x2;i++) setPix(i,y,SEG1,0);}*/

void vline(int x,int y1,int y2,char s)
	{int i;
	for(i=y1;i<=y2;i++) setPix(x,i,SEG1,s);}

/*void vlineOff(int x,int y1,int y2)
	{int i;
	for(i=y1;i<=y2;i++) setPix(x,i,SEG1,0);}*/

void rect(int x1,int y1,int x2,int y2)
	{hline(x1,x2,y1);
	hline(x1,x2,y2);
	vline(x1,y1,y2,1);
	vline(x2,y1,y2,1);}

void invRect(int x1,int y1,int x2,int y2)
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			invPix(i,j,SEG1);}

void fillRect(int x1,int y1,int x2,int y2,char state)
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			setPix(i,j,SEG1,state);}

void drawCadre(x1,y1,x2,y2)
	{rect(x1,y1,x2,y2);
	hline(x1+1,x2+1,y2+1);
	vline(x2+1,y1+1,y2+1,1);}

void fillCadre(int x1,int y1,int x2,int y2)
	{fillRect(x1-1,y1-1,x2+2,y2+2,0);
	drawCadre(x1,y1,x2,y2);}

void setPage1()
	{asm push ax;
	asm push bx;
	asm mov ah,05h;
	asm mov bh,0;
	asm int 10h;
	asm pop bx;
	asm pop ax;}

void setPage2()
	{asm push ax;
	asm push bx;
	asm mov ah,05h;
	asm mov bh,1;
	asm int 10h;
	asm pop bx;
	asm pop ax;}

/*deux fonctions  cause de bugs bizarres avec une seule fonction avec la page en argument*/

			/*******************************************************/ 
			/*			fonctions d'affichage du texte		*/ 
			/*******************************************************/

void drawChar(int x,int y,char c,unsigned int seg)
	{char nc;
	int i,j;
	if (c>=48 && c<=57) nc=c-48;
	if (c>=65 && c<=90) nc=c-55;
	if (c==' ') nc=36;
	if (c=='<') nc=37;
	if (c=='>') nc=38;
	if (c=='[') nc=39;
	if (c==']') nc=40;
	if (c==':') nc=41;
	if (c=='-') nc=42;
	if (c=='?') nc=43;
	if (c=='.') nc=44;
	for(i=0;i<5;i++) for(j=0;j<4;j++) setPix(x+j,y+i,seg,alpha[nc][i][j]);
	}

void drawString(int x,int y,char st[],unsigned int seg)
	{int i;
	for(i=0;st[i]!='\0';i++) drawChar(x+5*i,y,st[i],seg);}

/*affichage d'un nombre de l chiffres (moins de dix), align  droite*/
void drawNumFixe(int x,int y,long n,int l,unsigned int seg)
	{int i,d=0;
	long r=n;
	char st[10];/*a voir*/
	if(r<0) r=-r;
	for(i=l-1;i>=0;i--)
		{if (r==0 && i!=l-1)
			{d++;
			st[i]=' ';}
		else st[i]=48+r%10;
		r/=10;}
	if(n<0) st[d-1]='-';
	st[l]='\0';
	drawString(x,y,st,seg);}

/*affichage d'un nombre de 4 chiffre infrieur ou gal  1000*/
void drawNum2(int x,int y,int n,unsigned int seg)
	{int i;
	if (n==1000)
		{for(i=y;i<y+5;i++) setPix(x,i,SEG1,1);
		drawString(x+2,y,"000",seg);}
	else {int r=n;
		char st[4];
		for(i=y;i<y+5;i++) setPix(x,i,SEG1,0);
		for(i=2;i>=0;i--)
			{st[i]=(r==0 && i!=2?' ':48+r%10);
			r/=10;}
		st[3]='\0';
		drawString(x+2,y,st,seg);}
	}

void drawWind(int x,int y,int n)
	{int i,d=0;
	int r=n;
	char st[4];
	if(n<0) {d=1;st[0]='<';r=-n;}
	   else st[2]=(n==0?' ':'>');
	for(i=1;i>=0;i--)
		{st[d+i]=(r==0?' ':48+r%10);
		r/=10;}
	st[3]='\0';
	drawString(x,y,st,SEG1);}

void drawCurs(int n)
	{int x=9*cos((M_PI/180)*angle[n])+tankx[n];
	int y=9*sin((M_PI/180)*angle[n])+tanky[n]+1;
	invPix(x+1,56-y,SEG1);
	invPix(x-1,56-y,SEG1);
	invPix(x,56-y+1,SEG1);
	invPix(x,56-y-1,SEG1);}

void drawArme(int x,int y,int c,unsigned int seg)
	{int i,j;
	for(i=0;i<5;i++) for(j=0;j<14;j++)
		setPix(x+j,y+i,seg,armesPic[c][i][j]);}

void drawBarre(int md)
	{int i,j;
	for(j=0;j<16;j++)
	  for(i=0;i<8;i++)
		{unsigned int k=i+64*j;
		unsigned char v=barre[md][i+8*j];
		asm push es;asm push di;asm push si;
		asm mov ax,SEG1;
		asm mov es,ax;
		asm mov di,k;
		asm mov al,v;
		asm mov es:[di],al;
		asm pop si;asm pop di;asm pop es;
		}
	}

void drawFleche(int x,int y,int f,unsigned int seg)
	{int i,j;
	for(i=0;i<7;i++) for(j=0;j<5;j++)
		setPix(x+j,y+i,seg,fleche[f][i][j]);}

void saveListePics(int k)
	{int i,j;
	for (i=0;i<5;i++) clrHLine(i,SEG2);
	drawArme(11,0,k,SEG2);
	drawString(26,0,armesNoms[k],SEG2);
	drawNumFixe(91,0,armesPrix[k],4,SEG2);
	drawNumFixe(112,0,armesLots[k],2,SEG2);

	for(j=0;j<16;j++)
	  for(i=0;i<5;i++)
		{unsigned int o=59+i+64*j;
		unsigned char v;
		asm push es;asm push di;asm push si;
		asm mov ax,SEG2;
		asm mov es,ax;
		asm mov di,o;
		asm mov al,es:[di];
		asm mov v,al;
		asm pop si;asm pop di;asm pop es;
		listePics[k][i+5*j]=v;}
	}

void drawListePics(int k,int y)
	{int i,j;
	for(j=0;j<16;j++)
	  for(i=0;i<5;i++)
		{unsigned int o=(59-y)+i+64*j;
		unsigned char v=listePics[k][i+5*j];
		asm push es;asm push di;asm push si;
		asm mov ax,SEG1;
		asm mov es,ax;
		asm mov di,o;
		asm mov al,v;
		asm mov es:[di],al;
		asm pop si;asm pop di;asm pop es;
		}
	}

void drawListeArmes(int j,int dep)
	{int i,k;
	for (i=dep;i<dep+9;i++)
	  if(i<dispomax)
		{k=dispo[i];
		drawListePics(k,10+6*(i-dep));
		drawNumFixe(1,10+6*(i-dep),stock[j][k],2,SEG1);
		clrHLine(10+6*(i-dep)+5,SEG1);}
	  else for(k=0;k<6;k++) clrHLine(10+6*(i-dep)+k,SEG1);
	if (dep>0) drawFleche(122,10,0,SEG1);
	if (dep+9<dispomax) drawFleche(122,56,1,SEG1);
	}

void setDispo(int pl)
	{int i;
	dispomax=0;
	for(i=0;i<AMAX;i++) if (armesPrix[i]<=fric[pl]) {dispo[dispomax]=i;dispomax++;}
	}

void dispScores()
	{int x,y,dx,dy,i;
	dx=15*5;
	dy=(NP+1)*6;
	x=(128-dx)/2;
	y=((mcur==0?64:56)-dy)/2;
	fillCadre(x-2,y-1,x+dx+1,y+dy+1);
	if (mcur>1)
		{drawNumFixe(x+5,y,mcur,2,SEG1);
		drawString(x+17,y,"ROUNDS LEFT",SEG1);}
	else if (mcur==1) drawString(x+15,y,"LAST ROUND",SEG1);
		else drawString(x+16,y,"GAME OVER",SEG1);
	invRect(x-1,y,x+dx,y+5);
	for(i=0;i<NP;i++)
		{drawNumFixe(x,7+y+6*i,i+1,1,SEG1);
		drawString(x+8,7+y+6*i,noms[ordre[i]],SEG1);
		drawNumFixe(x+46,7+y+6*i,credits[ordre[i]],6,SEG1);}
	}



			/*******************************************************/
			/*			fonctions utiles diverses			*/ 
			/*******************************************************/


int waitkey()
	{int v=getch();
	if (v==0) v=getch();
	return v;}

void clrKeyBuff()
	{int i;
    pokeb(0x41, 0xA + CASIO, peekb(0x41, 0xC + CASIO));

    for (i=(0xE + CASIO); i<=(0x2C + CASIO); i+=2) {
    poke(0x41, i, 0x0000);}
    }

char readKeyb()
	{unsigned char key;
	asm push es;asm push di;asm push ax;
	asm mov ax,0x40;
	asm mov es,ax;
	asm mov di,0xAF;
	asm mov al,es:[di];
	asm mov key,al;
	asm pop ax;asm pop di;asm pop es;
	return key;}

long getNbr(int x,int y,int max)
	{int i,k=0;
	long val=0;
	drawChar(x,y,'>',SEG1);
	for(i=0;i<max && k!=EXE;i++)
		{while((k<48||k>57)&&(k!=EXE||i==0)) k=getch();
		if (k!=EXE)   {drawChar(x+5*(i+1),y,k,SEG1);
					val=val*10+k-48;k=0;}}
	return val;}

void getNom(int x,int y,int n)
	{int i,k=0,c=0;
	drawString(x,y,">     ",SEG1);
	for(i=0;i<5;i++) noms[n][i]=' ';
	for(i=0;i<5 && k!=EXE;i++)
		{while((k<46||k>57)&&(k<65||k>90)&&(k!=EXE||i==0)) k=getch();
		if (k!=EXE)   {c=k;
					if(k>=55 && k<=57) c+=22;
					if(k>=52 && k<=54) c+=28;
					if(k>=49 && k<=51) c+=36;
					if(k==48) c='Z';
					if(k==46) c=' ';
					drawChar(x+5*(i+1),y,c,SEG1);
					noms[n][i]=c;k=0;}}
	drawChar(x,y,' ',SEG1);
	}




int randomm(int pm)
	{return  pm*(double)rand()/32768;}

int ac(int x,int xmax)
	{int y=sqrt((xmax+0.5)*(xmax+0.5)-x*x);
	return y;}

void delayAsm()
	{asm push cx;
	asm mov cx,2000;
	asm rep nop;
	asm pop cx;}

int exitGame()
	{int k=0,cur=0;
	copyScreen(SEG1,SEG2);
	fillCadre(35,23,92,38);
	drawString(37,25,"GAME PAUSED",SEG1);
	drawString(37,32," MENU EXIT ",SEG1);
	while(k!=EXE && k!=ESC)
		{invRect(41+25*cur,31,61+25*cur,37);
		k=waitkey();
		invRect(41+25*cur,31,61+25*cur,37);
		if (k==75) cur=0;
		if (k==77) cur=1;}
	copyScreen(SEG2,SEG1);
	return (k==ESC? 0: 1+cur );}


			/*******************************************************/ 
			/*				fonctions utiles du jeu			*/ 
			/*******************************************************/

void earthfall()
	{int i,c,d,j;
	for (i=0;i<128;i++)
		{c=0;
		while(getPix(i,55-c,SEG1)==1 && c<sol[i]) c++;
		d=c;
		while(d<=sol[i])
			{d++;
			while(getPix(i,55-d,SEG1)==1 && d<=sol[i])
				{setPix(i,55-d,SEG1,0);
				setPix(i,55-c,SEG1,1);
				c++;
				d++;}
			}
		sol[i]=c;}
	}

void clrCircle(int x,int y,int r,int s)
	{int i,j,k;
	for (i=-r;i<=r;i++) if(y-i>0 && y-i<=56)
		{k=ac(i,r);
		for (j=-k;j<=k;j++) if(x+j>=0 && x+j<128)
			{setPix(x+j,56-y+i,SEG1,0);
			setPix(x+j,56-y+i,SEG2,s);}
		}
	}

void fillCircle(int x,int y,int r,int s,unsigned int seg)
	{int i,j,k;
	for (i=-r;i<=r;i++) if(y-i>0 && y-i<=56)
		{k=ac(i,r);
		for (j=-k;j<=k;j++) if(x+j>=0 && x+j<128)
			setPix(x+j,56-y+i,seg,s);
		}
	}

void fillDemiCircle(int x,int y,int r,int s,unsigned int seg)
	{int i,j,k;
	for (i=0;i<=r;i++) if(y+i>0 && y+i<=56)
		{k=ac(i,r);
		for (j=-k;j<=k;j++) if(x+j>=0 && x+j<128)
			setPix(x+j,56-(y+i),seg,s);
		}
	}

void landGen()
	{int y,inc,i,imax;
	imax=(bump==0?1+randomm(6):bump);
	y=randomm(55-hv);
	inc=randomm(2*imax+1)-imax;
	for(i=0;i<128;i++)
		{inc+=randomm(3)-1;
		if (inc==imax+1)	inc=(imax-1)+randomm(2);
		if (inc==-(imax+1)) inc=-(imax-1)-randomm(2);
		if (y>=55-hv-20 && inc==6) inc=4+randomm(2);
		if (y>=55-hv-14 && inc==5) inc=3+randomm(2);
		if (y>=55-hv-9 && inc==4) inc=2+randomm(2);
		if (y>=55-hv-5 && inc==3) inc=1+randomm(2);
		if (y>=55-hv-2 && inc==2) inc=randomm(2);
		if (y==55-hv && inc==1) inc=randomm(2)-1;

		if (y<=20 && inc==-6) inc=randomm(2)-5;
		if (y<=14 && inc==-5) inc=randomm(2)-4;
		if (y<=9 && inc==-4) inc=randomm(2)-3;
		if (y<=5 && inc==-3) inc=randomm(2)-2;
		if (y<=2 && inc==-2) inc=randomm(2)-1;
		if (y==0 && inc==-1) inc=randomm(2);
		y+=inc;
		sol[i]=y;}
	}

void drawLand()
	{int i,j;
	for (j=56-hv;j>=0;j--)
		{for(i=0;i<128;i++)
			if (sol[i]-j > 0) setPix(i,56-(sol[i]-j),SEG1,1);/* >= */
		delay(10);}
	}

void drawPara(int n,unsigned int seg,int s)
	{int i,x,y;
	if (s==1)
		for(i=0;i<22;i++)  {x=paraPic[0][i];y=paraPic[1][i];
						paraPix[i]=getPix(tankx[n]+x,56-(tanky[n]+y),seg);
						setPix(tankx[n]+x,56-(tanky[n]+y),seg,1);}
	else for(i=0;i<22;i++)  {x=paraPic[0][i];y=paraPic[1][i];
						setPix(tankx[n]+x,56-(tanky[n]+y),seg,paraPix[i]);}
	}

void drawTank(int n,unsigned int seg,int s,int par)
	{int i;
	for(i=-2;i<=2;i++) setPix(tankx[n]+i,56-tanky[n],seg,s);
	for(i=-1;i<=1;i++) setPix(tankx[n]+i,56-tanky[n]-1,seg,s);
	if (par==1) drawPara(n,SEG1,s);}

void setTankPos()
	{int i;
	for (i=0;i<NP;i++) if (bat[i]>0) drawTank(i,SEG2,1,0);}

void placeTank(int n)
	{int i,m1,m2,m3,smax;
	int x=tankx[n];
	m1=x-2;
	for (i=x-2;i<=x+2;i++) if(sol[i]>sol[m1]) m1=i;
	m2=x-2;
	if (m1==x-2) m2=x-1;
	for (i=x-2;i<=x+2;i++) if(i!=m1 && sol[i]>sol[m2]) m2=i;
	m3=x-2;
	if (m1==x-2 || m2==x-2) m3=x-1;
	if (m1==x-1 || m2==x-1) m3=x;
	for (i=x-2;i<=x+2;i++) if(i!=m1 && i!=m2 && sol[i]>sol[m3]) m3=i;
	smax=sol[m1];
	if (sol[m2]<smax) smax=sol[m2];
	if (sol[m3]<smax) smax=sol[m3];
	sol[m1]=smax;vline(m1,0,56-(smax+1),0);
	sol[m2]=smax;vline(m2,0,56-(smax+1),0);
	sol[m3]=smax;vline(m3,0,56-(smax+1),0);
	tanky[n]=smax+1;}

void fallTank(int n)
	{int ok=0,d=200,d2=400;
	while (ok==0)
		{int s0=tanky[n]-1-sol[tankx[n]];
		int sg1=tanky[n]-1-sol[tankx[n]-1];int sd1=tanky[n]-1-sol[tankx[n]+1];
		int sg2=tanky[n]-1-sol[tankx[n]-2];int sd2=tanky[n]-1-sol[tankx[n]+2];
		int sg3=tanky[n]-1-sol[tankx[n]-3];int sd3=tanky[n]-1-sol[tankx[n]+3];
		if (tankx[n]==2) sg3=-1;
		if (tankx[n]==127-2) sd3=-1;
		drawTank(n,SEG1,0,(d==d2?1:0));
		if(sg1==0 || s0==0 || sd1==0) ok=1;
			else if(sg2>0 && sd2>0) tanky[n]--;
				else if(sg2==0 && sd2==0) ok=1;
					else if (sg2==0 && sg1>=2 && sd3>=1) {tankx[n]++;tanky[n]--;}
						else if (sd2==0 && sd1>=2 && sg3>=1) {tankx[n]--;tanky[n]--;}
							else ok=1;
		if (d==200 && ok==0 && stock[n][14]>0 && bat[n]>0) {d=d2;stock[n][14]--;}
		if (ok==0 && d==200) bat[n]=(bat[n]<50?0:bat[n]-50);
		drawTank(n,SEG1,1,(d==d2?1:0));
		delay(d);}
	if (d==d2) drawPara(n,SEG1,0);
	}

void shoot(int x,int y,int alpha0,int v0,int mode)
	{int i,j,k;
	v[0]=0.2*v0*cos((M_PI/180)*alpha0)*dt;
	v[1]=0.2*v0*sin((M_PI/180)*alpha0)*dt;
	om[0]=x+3*cos((M_PI/180)*alpha0);
	om[1]=y+3*sin((M_PI/180)*alpha0);
	for (i=0;i<TMAX;i++) {pt[i][0]=om[0];pt[i][1]=om[1];}
	clrScreen(SEG2);
	setTankPos();

	a=0;b=1;
	stop=0;
	while (stop==0)
		{setPix(pt[b][0],56-pt[b][1],SEG1,0);
		setPix(pt[a][0],56-pt[a][1],SEG1,1);
		a=b;b=(b+1)%TMAX;
		v[0]+=wdt2;
		v[1]-=gdt2;
		om[0]+=v[0];
		om[1]+=v[1];
		pt[a][0]=om[0];
		pt[a][1]=om[1];
		delay(10);
		if (pt[a][0]>=0 && pt[a][0]<128 && pt[a][1]<=sol[pt[a][0]]) stop=1;
		if ((pt[a][0]<0 && pt[a][1]<=sol[0]) || (pt[a][0]>=128 && pt[a][1]<=sol[127])) stop=2;
		if (pt[a][0]>=0 && pt[a][0]<128 && pt[a][1]<=56 && getPix(pt[a][0],56-pt[a][1],SEG2)==1) stop=3;
		if(pt[a][0]<0) pt[a][0]=0;
		if(pt[a][0]>=128) pt[a][0]=127;
		if(pt[a][1]>56) pt[a][1]=56;
		if (mode==1 && v[1]<=0) stop=4;}
	if (stop!=4)
		for (i=b;i<b+TMAX-1;i++)
			setPix(pt[i%TMAX][0],56-pt[i%TMAX][1],SEG1,0);
	}

void explosion(int x,int y,int r)
	{int i,j,k;
	copyScreen(SEG1,SEG2);
	for(k=1;k>=0;k--)
	  for(j=1;j<=r;j++)	{clrCircle(x,y,j,k);
					for(i=0;i<=500;i++)	{if ((i%5)==0) setPage1();
									if ((i%5)==2) setPage2();
									delayAsm();}}
	setPage1();
	delay(300);}

void explMulti(int x[],int y[],int n,int r)
	{int i,j,k,l;
	copyScreen(SEG1,SEG2);
	for(l=1;l>=0;l--)
	   for(j=1;j<=r;j++)
	      for(k=0;k<n;k++)
			{clrCircle(x[k],y[k],j,l);
			for(i=0;i<=150;i++)	{if ((i%5)==0) setPage1();
							if ((i%5)==2) setPage2();
							delayAsm();}}
	setPage1();
	delay(500);}

int toucheTank(int t,int x,int y)
	{int val=0;
	if (x>=tankx[t]-2 && x<=tankx[t]+2 && y==tanky[t] || x>=tankx[t]-1 && x<=tankx[t]+1 && y==tanky[t]+1) val=1;
	return val;}

void addFric(int t,int f)
	{credits[t]+=f;
	fric[t]+=f;
	if (fric[t]<0) fric[t]=0;}

void killTanks(int x,int y,int r,int p)/*int p -> calcul des points en fonction du joueur*/
	{int i;
	if (x>=0 && x<128)
	  for(i=0;i<NP;i++) if (bat[i]>0)
		{if (toucheTank(i,x,y)==1)
			{bat[i]=0;addFric(p,(i==p?-150:350));}
		else if ((tankx[i]-x)*(tankx[i]-x)+(tanky[i]-y)*(tanky[i]-y)<=r*r)
			{bat[i]=0;addFric(p,(i==p?-150:350));}}
	}

       void clrscr(){
        clrScreen(SEG1);
        gotoxy(0,0);
       }
       unsigned char get_time(unsigned char what){
if(what!=1&&what!=2&&what!=3) return 0;
asm {
xor ax,ax
mov dx,0x0020
mov al,what
sub dx,ax
in al,dx };
return _AL; }



int i,j,k;
	char c=0;
	int key=0;
	int choix;
void ennd();
void menu()
{
 clrscr();
	drawPict(intro,SEG1);
	do	{invMenuLine(c);
		key=waitkey();
		invMenuLine(c);
		if (key==ESC && exitGame()==2) ennd();
		if(key==kleft || key==kright) c=(c+2)%4;
		if(key==kup)	c=(c+4-1)%4;
		if(key==kdown) c=(c+1)%4;} while(key!=EXE);
	if (c==3) ennd();
	
	if (c==1)	{int d=0;
			clrscr();
			drawString(1,1,"GAME SETTINGS",SEG1);
			invAlphaLine(0);
			drawString(3,10,"NUMBER OF PLAYERS:",SEG1);	drawNumFixe(96,10,NP,6,SEG1);
			drawString(3,16,"NUMBER OF ROUNDS:",SEG1);	drawNumFixe(96,16,mmax,6,SEG1);
			drawString(3,22,"LAND BUMPINESS:",SEG1);	if(bump==0) drawString(96,22,"RANDOM",SEG1);
												else drawNumFixe(96,22,bump,6,SEG1);
			drawString(3,28,"MAX SKY HEIGHT:",SEG1);	drawNumFixe(96,28,hv,6,SEG1);
			drawString(3,34,"CASH AT START:",SEG1);		drawNumFixe(96,34,fricdeb,6,SEG1);
			drawString(3,40,"INTEREST RATE:",SEG1);		drawNumFixe(96,40,taux,6,SEG1);
			drawString(3,46,"PLAYER  :",SEG1);			drawNumFixe(38,46,(d+1),1,SEG1);
												drawString(101,46,noms[d],SEG1);
			drawString(3,52,"WIND MAX :",SEG1);		drawNumFixe(96,52,wmax,6,SEG1);
			c=0;
			do	{invAlphaLine(9+6*c);
				key=waitkey();
				invAlphaLine(9+6*c);
				if(key==kup)	c=(c+8-1)%8;
				if(key==kdown) c=(c+1)%8;
				if((key==kleft||key==kright) && c==2)
					{bump=(bump+(key==kleft?-1:1)+7)%7;
					if(bump==0) drawString(96,22,"RANDOM",SEG1);
					else drawNumFixe(96,22,bump,6,SEG1);}
				if((key==kleft||key==kright) && c==6)
					{d=(d+(key==kleft?-1:1)+NP)%NP;
					drawNumFixe(38,46,d+1,1,SEG1);
					drawString(101,46,noms[d],SEG1);}
				if(key==EXE && c!=2 && c!=6)
					{long v;
					drawString(96,10+6*c,"      ",SEG1);
					v=getNbr(96,10+6*c,5);
					if(c==0) {if(v>PMAX)	v=PMAX;	NP=v;}	
					if(c==1) {if(v>500)		v=500;	mmax=v;}
					if(c==3) {if(v>50)		v=50;	if (v<6) v=6;	hv=v;}
					if(c==4) {if(v>50000)	v=50000;	fricdeb=v;}
					if(c==5) {if(v>100)		v=100;	taux=v;}
					if(c==7) {if(v>100)		v=100;	wmax=v;}
					drawNumFixe(96,10+6*c,v,6,SEG1);
					}
				if(key==EXE && c==6) getNom(96,46,d);
				
				} while(key!=ESC);
			c=1;
			choix=MENU; return;//goto menu;
			}

	if (c==2)	{clrscr();
			drawString(1,1,"HELP: MAIN KEYS",SEG1);
			invAlphaLine(0);
			drawString(2,10,"DURING GAME:",SEG1);
			drawString(10,17,"[CTRL]:TOGGLE MODE",SEG1);
			drawString(10,23,"[I]:INVENTORY",SEG1);
			drawString(10,29,"[F1]-[F2]:CHANGE9 WEAPON",SEG1);
			drawString(10,35,"[EXE]:SHOOT",SEG1);
			drawString(2,43,"IN THE MARKET MENU:",SEG1);
			drawString(10,50,"[->]:PASS TURN",SEG1);
			drawString(10,56,"[EXE]:BUY ITEM",SEG1);
			waitkey();
			choix=MENU; return;}

	mcur=mmax;
	for (i=0;i<NP;i++) {fric[i]=fricdeb;
					ordre[i]=NP-i-1;
					credits[i]=0;
					asel[i]=0;
					stock[i][0]=99;
					for(j=1;j<AMAX;j++) stock[i][j]=0;}

 choix=NEWROUND;return;
}



void newround()
{

	for (q=0;q<NP;q++)
	  {setDispo(ordre[q]);
	  if(dispomax>1)
		{p=ordre[q];
		clrscr();
		k=0;
		drawString(1,1,noms[p],SEG1);
		drawNumFixe(98,1,fric[p],6,SEG1);
		invAlphaLine(0);
		drawListeArmes(p,9*k);
		j=0;key=0;
		while(key!=NEXT && dispomax>1)
			{i=dispo[j];
			invAlphaLine(9+6*(j-9*k));
			key=waitkey();
			invAlphaLine(9+6*(j-9*k));
			if (key==EXE)
				{if (fric[p]>=armesPrix[i] && stock[p][i]<100-armesLots[j])
					{stock[p][i]+=armesLots[i];
					fric[p]-=armesPrix[i];}
				else if (stock[p][i]>=100-armesLots[i])
					{int pr=(99-stock[p][i])*armesPrix[i]/armesLots[i];
					if (fric[p]>=pr)
						{stock[p][i]=99;
						fric[p]-=pr;}}
				invAlphaLine(0);
				drawNumFixe(98,1,fric[p],6,SEG1);
				invAlphaLine(0);
				setDispo(p);
				if (j>=dispomax) j=dispomax-1;
				k=j/9;
				drawListeArmes(p,9*k);}
			if (key==kup && j>0)		  {j--;if(j%9==8) {k--;drawListeArmes(p,9*k);}}
			if (key==kdown && j<dispomax-1) {j++;if(j%9==0) {k++;drawListeArmes(p,9*k);}}
			if (key==ESC) {i=exitGame();
						if (i==1) {choix=MENU; return;}
						if (i==2) ennd();}
			}
		}
	  }

	for (i=0;i<NP;i++) fric[i]+=(fric[i]*taux)/100;

	clrscr();
	landGen();
	drawBarre(0);
	barreMode=0;

	for(i=0;i<NP;i++)
		{tankx[i]=128/(2*NP)+i*128/NP;
		placeTank(i);
		bat[i]=1000;
		angle[i]=30+120*tankx[i]/128;
		power[i]=200;
		asel[i]=0;}

	for (i=0;i<NP;i++) drawTank(i,SEG1,1,0);
	drawLand();

	w=randomm(2*wmax+1)-wmax;
	wdt2=w*dt*dt;
	gdt2=g*dt*dt;
	i=0;
	q=0;
choix=PLAY;return;
}


void play()
{
	p=ordre[NP-q-1];
	while (stock[p][asel[p]]==0) asel[p]=(asel[p]+1)%AMAX1;
	if (power[p]>bat[p]) power[p]=bat[p];

	drawWind(113,1,w);

	if (barreMode==0)
		{drawString(1,58,noms[p],SEG1);
		drawNum2(39,58,bat[p],SEG1);
		drawNum2(67,58,power[p],SEG1);
		drawNumFixe(91,58,(angle[p]<=90?angle[p]:180-angle[p]),2,SEG1);
		drawNumFixe(103,58,stock[p][asel[p]],2,SEG1);
		drawArme(113,58,asel[p],SEG1);}
	else {drawNum2(12,58,bat[p],SEG1);
		drawNumFixe(31,58,stock[p][13],2,SEG1);
		drawNumFixe(55,58,stock[p][14],2,SEG1);
		drawNumFixe(77,58,stock[p][15],2,SEG1);}

	for (i=0;i<NP;i++) if (bat[i]>0) drawTank(i,SEG1,1,0);

	drawCurs(p);

	key=waitkey();

	drawCurs(p);

	if (key==kleft || key==kright)
		{int inc=(key==kleft?1:-1);
		angle[p]=(angle[p]+inc+181)%181;
		drawCurs(p);
		if (barreMode==0) drawNumFixe(91,58,(angle[p]<=90?angle[p]:180-angle[p]),2,SEG1);
		delay(800);
		key=readKeyb();
		while(key==kleft || key==kright)
			{inc=(key==kleft?1:-1);
			drawCurs(p);
			angle[p]=(angle[p]+inc+181)%181;
			drawCurs(p);
			if (barreMode==0) drawNumFixe(91,58,(angle[p]<=90?angle[p]:180-angle[p]),2,SEG1);
			key=readKeyb();}
		clrKeyBuff();
		drawCurs(p);}

	if (key==kup || key==kdown)
		{int inc=(key==kup?1:-1);
		power[p]=power[p]+inc;
		if (power[p]<0) power[p]=0;
		if (power[p]>bat[p]) power[p]=bat[p];
		if (barreMode==0) drawNum2(67,58,power[p],SEG1);
		delay(800);
		key=readKeyb();
		while(key==kup || key==kdown)
			{inc=(key==kup?1:-1);
			power[p]=power[p]+inc;
			if (power[p]<0) power[p]=0;
			if (power[p]>bat[p]) power[p]=bat[p];
			if (barreMode==0) drawNum2(67,58,power[p],SEG1);
			key=readKeyb();}
		clrKeyBuff();}

	if (key==59)  do {asel[p]=(asel[p]-1+AMAX1)%AMAX1;} while (stock[p][asel[p]]==0);
	if (key==60)  asel[p]=(asel[p]+1)%AMAX1;

	if (key==73) /* [I] -> inventory*/
		{int nx,ny;
		int xd,yd;
		copyScreen(SEG1,SEG2);
		k=0;
		for(i=0;i<AMAX1;i++) if (stock[p][i]!=0) k++;
		nx=4;
		ny=1+(k-1)/nx;
		xd=(128-(15*nx+2))/2;
		yd=(56-(6*ny+8))/2+6;
		fillCadre(xd-2,yd-2-6,xd+15*nx,yd+6*ny);
		drawString(xd-1,yd-6-1,"INVENTORY:",SEG1);
		invRect(xd-1,yd-6-1,xd+15*nx-1,yd-2);
		k=0;
		for(i=0;i<AMAX1;i++) if (stock[p][i]!=0)
			{drawArme(xd+15*(k%nx),yd+6*(k/nx),i,SEG1);
			k++;}

		key=0;
		i=0;
		for(j=0;j<asel[p];j++) if (stock[p][j]!=0) i++;

		while(key!=EXE && key!=ESC && key !=73)
			{invRect(xd+15*(i%nx)-1,yd+6*(i/nx)-1,xd+15*(i%nx)+14,yd+6*(i/nx)+5);
			key=waitkey();
			invRect(xd+15*(i%nx)-1,yd+6*(i/nx)-1,xd+15*(i%nx)+14,yd+6*(i/nx)+5);
			if (key==kleft && i%nx>0) i--;  
			if (key==kright && i%nx<nx-1 && i<k-1) i++;
			if (key==kup && i-nx>=0) i-=4;
			if (key==kdown && i+nx<k) i+=4;}
		k=0;
		for(j=0;j<AMAX1 && k<i;j++) if (stock[p][j]!=0) k++;
		asel[p]=j;
		copyScreen(SEG2,SEG1);
		key=0;
		}

	if (key==66 && stock[p][13]>0 && bat[p]<1000) /* [B] -> battery */
		{stock[p][13]--;
		bat[p]+=100;
		if (bat[p]>1000) bat[p]=1000;}

	if (key==CTRL) /* [CTRL] -> toggle mode */
		{barreMode=(barreMode+1)%2;
		drawBarre(barreMode);}

	if (key==70 && stock[p][15]>0) /* [F] -> fuel */
		{int moves=5*stock[p][15];
		key=0;
		drawBarre(1);
		while(key!=ESC && key!=EXE && key!=70 && bat[p]>0 && moves>0)
			{drawTank(p,SEG1,1,0);

			drawNum2(12,58,bat[p],SEG1);
			drawNumFixe(31,58,stock[p][13],2,SEG1);
			drawNumFixe(55,58,stock[p][14],2,SEG1);
			drawString(77,58,"  ",SEG1);
			drawNumFixe(105,58,moves,3,SEG1);

			key=waitkey();
			drawTank(p,SEG1,0,0);
			if (key==kleft && tankx[p]-2>0)
				{int max=0;
				for(i=tankx[p]-2-1;i<=tankx[p]+2-1;i++) if (sol[i]>max) max=sol[i];
				if (max<tanky[p] || max==tanky[p] && (sol[tankx[p]-3]-sol[tankx[p]-2])<2)
					{tankx[p]--;
					if (max==tanky[p]) tanky[p]++;
					if (max<tanky[p]-1) tanky[p]--;
					fallTank(p);
					moves--;}
				}
			if (key==kright && tankx[p]+2<128-1)
				{int max=0;
				for(i=tankx[p]-2+1;i<=tankx[p]+2+1;i++) if (sol[i]>max) max=sol[i];
				if (max<tanky[p] || max==tanky[p] && (sol[tankx[p]+3]-sol[tankx[p]+2])<2)
					{tankx[p]++;
					if (max==tanky[p]) tanky[p]++;
					if (max<tanky[p]-1) tanky[p]--;
					fallTank(p);
					moves--;}
				}
			}
		key=0;
		stock[p][15]=moves/5;
		if (bat[p]==0) choix=ENDTURN;return;//goto endturn;
		drawString(105,58,"   ",SEG1);
		drawNumFixe(77,58,stock[p][15],2,SEG1);
		drawBarre(barreMode);
		}

	if (key==ESC) {i=exitGame();
				if (i==1) choix=MENU; return;
				if (i==2) ennd();}

	if (key!=EXE) {choix=PLAY;return;}

	if (asel[p]!=0) stock[p][asel[p]]--;

/* Missile */
	if (asel[p]<4)
		{shoot(tankx[p],tanky[p],angle[p],power[p],0);
		if (stop!=2) explosion(om[0],om[1],armesRay[asel[p]]);
		killTanks(om[0],om[1],armesRay[asel[p]],p);}

/* Roller */
	if (asel[p]==4)
		{shoot(tankx[p],tanky[p],angle[p],power[p],0);
		if (stop==1)
			{int direc=(v[0]>0?1:-1);
			int rol[2];
			rol[0]=pt[(a-1+TMAX)%TMAX][0];
			rol[1]=sol[rol[0]]+1;
			if (sol[rol[0]+direc]>=rol[1]) direc=-direc;
			for(i=0;i<RMAX;i++) {pt[i][0]=rol[0];pt[i][1]=rol[1];}
			clrScreen(SEG2);
			setTankPos();

			a=0;b=1;
			stop=0;
			while (stop==0)
				{setPix(pt[b][0],56-pt[b][1],SEG1,0);
				setPix(pt[a][0],56-pt[a][1],SEG1,1);
				a=b; b=(b+1)%RMAX;
				delay(100);
				if (rol[1]>sol[rol[0]]+1) rol[1]--;
					else rol[0]+=direc;
				pt[a][0]=rol[0]; pt[a   ][1]=rol[1];
				if (rol[1]<=sol[rol[0]]) stop=1;
				if ((rol[0]<0 && rol[1]<=sol[0]) || (rol[0]>=128 && rol[1]<=sol[127])) stop=2;
				if (rol[0]>=0 && rol[0]<128 && rol[1]<=56 && getPix(rol[0],56-rol[1],SEG2)==1) stop=3;
				}
			for (i=b;i<b+RMAX-1;i++)
				setPix(pt[i%RMAX][0],56-pt[i%RMAX][1],SEG1,0);
			om[0]=rol[0];om[1]=rol[1];
			}
		if (stop!=2) explosion(om[0],om[1],armesRay[asel[p]]);
		killTanks(om[0],om[1],armesRay[asel[p]],p);
		}

/* MIRV */
	if (asel[p]==5)
		{shoot(tankx[p],tanky[p],angle[p],power[p],1);
		if (stop==4)
			{double mx[5];
			double my=om[1];
			double vd[5];
			int stat[]={0,0,0,0,0};
			for(i=0;i<5;i++)   {vd[i]=(i-2)*0.1;
							mx[i]=om[0];}
			for (j=0;j<TMAX;j++) for(i=0;i<5;i++)  {ptx[i][j]=pt[j][0];
											pty[i][j]=pt[j][1];}
			clrScreen(SEG2);
			setTankPos();

			stop=0;
			while (stop==0)
				{for(i=0;i<5;i++)
					{setPix(ptx[i][b],56-pty[i][b],SEG1,0);
					setPix(ptx[i][a],56-pty[i][a],SEG1,1);}
				a=b;b=(b+1)%TMAX;
				v[0]+=wdt2;
				v[1]-=gdt2;
				my+=v[1];
				for(i=0;i<5;i++)
					if (stat[i]==0){mx[i]+=(v[0]+vd[i]);
								ptx[i][a]=mx[i];pty[i][a]=my;}
					else		{ptx[i][a]=ptx[i][(a-1+TMAX)%TMAX];
							pty[i][a]=pty[i][(a-1+TMAX)%TMAX];}
				delay(10);
				for (i=0;i<5;i++) if (stat[i]==0)
					{if (ptx[i][a]>=0 && ptx[i][a]<128 && pty[i][a]<=sol[ptx[i][a]]) stat[i]=1;
					if ((ptx[i][a]<0 && pty[i][a]<=sol[0]) || (ptx[i][a]>=128 && pty[i][a]<=sol[127])) stat[i]=2;
					if (ptx[i][a]>=0 && ptx[i][a]<128 && pty[i][a]<=56 && getPix(ptx[i][a],56-pty[i][a],SEG2)==1) stat[i]=3;
					}
				for(i=0;i<5;i++) if (stat[i]==0)
					{if(ptx[i][a]<0) ptx[i][a]=0;
					if(ptx[i][a]>=128) ptx[i][a]=127;
					if(pty[i][a]>56) pty[i][a]=56;}
				if (stat[0]!=0 && stat[1]!=0 && stat[2]!=0 && stat[3]!=0 && stat[4]!=0) stop=1;
				}
			for(i=0;i<5;i++) for (j=b;j<b+TMAX-1;j++)
				setPix(ptx[i][j%TMAX],56-pty[i][j%TMAX],SEG1,0);

			if (stat[0]!=2 || stat[1]!=2 || stat[2]!=2 || stat[3]!=2 || stat[4]!=2)
				{k=0;
				for(i=0;i<5;i++)  if (stat[i]!=2)	{explx[k]=ptx[i][a];
											exply[k]=pty[i][a];
											k++;}
				explMulti(explx,exply,k,armesRay[asel[p]]);
				for(i=0;i<k;i++) killTanks(explx[i],exply[i],armesRay[asel[p]],p);
				}
			}
		}

/* Leapfrog */
	if (asel[p]==6)
		{char coef[]={4,3,2};
		stop=0;om[0]=tankx[p];om[1]=tanky[p];
		for(i=0;i<3 && stop!=2;i++)
			{shoot(om[0],om[1],angle[p],coef[i]*power[p]/4,0);
			if (stop!=2)  {explosion(om[0],om[1],coef[i]*armesRay[asel[p]]/4);
						earthfall();
						killTanks(om[0],om[1],coef[i]*armesRay[asel[p]]/4,p);}}
		}

/* Riot Bomb */
	if (asel[p]==7)
		{shoot(tankx[p],tanky[p],angle[p],power[p],0);
		if (stop!=2)  {int x=om[0],y=om[1];
					copyScreen(SEG1,SEG2);
					fillCircle(x,y,armesRay[asel[p]],0,SEG1);
					for(i=0;i<=1000;i++){if ((i%5)==0) setPage1();
									if ((i%5)==2) setPage2();
									delayAsm();}
					for(j=1;j<=armesRay[asel[p]];j++)
						{fillCircle(x,y,j,0,SEG2);
						for(i=0;i<=750;i++)	{if ((i%5)==0) setPage1();
										if ((i%5)==2) setPage2();
										delayAsm();}}
					setPage1();
					delay(500);}
		}

/* Riot Blast */
	if (asel[p]==8)
		{int x=tankx[p],y=tanky[p];
		copyScreen(SEG1,SEG2);
		fillDemiCircle(x,y,armesRay[asel[p]],0,SEG1);
		drawTank(p,SEG1,1,0);
		for(i=0;i<=750;i++){if ((i%5)==0) setPage1();
						if ((i%5)==2) setPage2();
						delayAsm();}
		for(j=1;j<=armesRay[asel[p]];j++)
			{fillDemiCircle(x,y,j,0,SEG2);
			drawTank(p,SEG2,1,0);
			for(i=0;i<=750;i++){if ((i%5)==0) setPage1();
							if ((i%5)==2) setPage2();
							delayAsm();}}
		setPage1();
		delay(500);}

/* Napalm */
	if (asel[p]==9)
		{shoot(tankx[p],tanky[p],angle[p],power[p],0);
		if (stop!=2)
			{int x=pt[(a-1+TMAX)%TMAX][0];
			int y=1+sol[x];
			int nap[NMAX][2];
			int npoints=0;
			int napmax=armesRay[asel[p]];
			int coulg[2],could[2];
			int cx;
			int ok=0;
			coulg[0]=x;coulg[1]=y;
			could[0]=x;could[1]=y;
			copyScreen(SEG1,SEG2);
			for(i=0;i<NP;i++) if(bat[i]>0) drawTank(i,SEG2,0,0);
			setPix(x,56-y,SEG2,1);
			setPage2();
			while (npoints<napmax)
				{ok=0;
				if (coulg[1]>0 && getPix(coulg[0],56-(coulg[1]-1),SEG2)==0)
					{coulg[1]--;ok=1;
					setPix(coulg[0],56-coulg[1],SEG2,1);npoints++;
					if (npoints<NMAX) {nap[npoints][0]=coulg[0];nap[npoints][1]=coulg[1];}}
				else if (coulg[0]<127 && getPix(coulg[0]+1,56-coulg[1],SEG2)==0)
					{coulg[0]++;ok=1;
					setPix(coulg[0],56-coulg[1],SEG2,1);npoints++;
					if (npoints<NMAX) {nap[npoints][0]=coulg[0];nap[npoints][1]=coulg[1];}}

				if (could[1]>0 && getPix(could[0],56-(could[1]-1),SEG2)==0)
					{could[1]--;ok=1;
					setPix(could[0],56-could[1],SEG2,1);npoints++;
					if (npoints<NMAX) {nap[npoints][0]=could[0];nap[npoints][1]=could[1];}}
				else if (could[0]>0 && getPix(could[0]-1,56-could[1],SEG2)==0)
					{could[0]--;ok=1;
					setPix(could[0],56-could[1],SEG2,1);npoints++;
					if (npoints<NMAX) {nap[npoints][0]=could[0];nap[npoints][1]=could[1];}}

				if (ok==0)
					{if (coulg[1]<56 && coulg[1]<could[1])
						{coulg[1]++;
						if (coulg[0]<127 && getPix(coulg[0]+1,56-coulg[1],SEG2)==0) coulg[0]++;
						cx=coulg[0];
						while (getPix(cx,56-coulg[1],SEG2)==0 && cx>=could[0])
							{setPix(cx,56-coulg[1],SEG2,1);npoints++;cx--;
							if (npoints<NMAX) {nap[npoints][0]=cx;nap[npoints][1]=coulg[1];}}}

					else if (could[1]<56 && could[1]<coulg[1])
						{could[1]++;
						if (could[0]>0 && getPix(could[0]-1,56-could[1],SEG2)==0) could[0]--;
						cx=could[0];
						while (getPix(cx,56-could[1],SEG2)==0 && cx<=coulg[0])
							{setPix(cx,56-could[1],SEG2,1);npoints++;cx++;
							if (npoints<NMAX) {nap[npoints][0]=cx;nap[npoints][1]=could[1];}}}
					
					else if (could[1]<56 && could[1]==coulg[1])
						{coulg[1]++;could[1]++;
						if (coulg[0]<127 && getPix(coulg[0]+1,56-coulg[1],SEG2)==0) coulg[0]++;
						if (could[0]>0 && getPix(could[0]-1,56-could[1],SEG2)==0) could[0]--;
						cx=coulg[0];
						while (getPix(cx,56-coulg[1],SEG2)==0 && cx>=could[0])
							{setPix(cx,56-coulg[1],SEG2,1);npoints++;cx--;
							if (npoints<NMAX) {nap[npoints][0]=cx;nap[npoints][1]=coulg[1];}}
						cx=could[0];
						while (getPix(cx,56-could[1],SEG2)==0 && cx<=coulg[0])
							{setPix(cx,56-could[1],SEG2,1);npoints++;cx++;
							if (npoints<NMAX) {nap[npoints][0]=cx;nap[npoints][1]=could[1];}}}
					}
				}
			for(i=0;i<NP;i++) if(bat[i]>0) drawTank(i,SEG2,1,0);
			for(i=0;i<=8000;i++){if ((i%5)==0) setPage1();
							if ((i%5)==3) setPage2();
							delayAsm();}
			setPage1();
			if(npoints>NMAX) npoints=NMAX;
			for(j=0;j<NP;j++)
			  for (i=0;i<npoints;i++)
				if(toucheTank(j,nap[i][0],nap[i][1]) && bat[j]>0)
					{bat[j]=(bat[j]>200?bat[j]-200:0);addFric(p,(j==p?-30:70));}
			}
		}

/* Funky Bomb */
	if (asel[p]==10)
		{shoot(tankx[p],tanky[p],angle[p],power[p],0);
		if (stop!=2)
			{double mx[FMAX];
			double my[FMAX];
			int x=om[0],y=om[1];
			double vm[FMAX][2];
			int stat[FMAX];
			for(i=0;i<FMAX;i++)
				{int alpha0=30+randomm(121);
				int v0=50+randomm(200);
				vm[i][0]=0.2*v0*cos((M_PI/180)*alpha0)*dt;
				vm[i][1]=0.2*v0*sin((M_PI/180)*alpha0)*dt;
				mx[i]=x+3*cos((M_PI/180)*alpha0);
				my[i]=y+3*sin((M_PI/180)*alpha0);
				for (j=0;j<TMAX;j++)
					{ptx[i][j]=mx[i];
					pty[i][j]=my[i];}
				stat[i]=0;}

			clrScreen(SEG2);
			setTankPos();

			stop=0;
			while (stop==0)
				{for(i=0;i<FMAX;i++)
					{setPix(ptx[i][b],56-pty[i][b],SEG1,0);
					setPix(ptx[i][a],56-pty[i][a],SEG1,1);}

				a=b;b=(b+1)%TMAX;
				k=0;
				for(i=0;i<FMAX;i++)
				  if (stat[i]==0)
					{vm[i][0]+=wdt2;
					vm[i][1]-=gdt2;
					mx[i]+=vm[i][0];
					my[i]+=vm[i][1];
					ptx[i][a]=mx[i];
					pty[i][a]=my[i];
					if (ptx[i][a]>=0 && ptx[i][a]<128 && pty[i][a]<=sol[ptx[i][a]]) stat[i]=1;
					if ((ptx[i][a]<0 && pty[i][a]<=sol[0]) || (ptx[i][a]>=128 && pty[i][a]<=sol[127])) stat[i]=2;
					if (ptx[i][a]>=0 && ptx[i][a]<128 && pty[i][a]<=56 && getPix(ptx[i][a],56-pty[i][a],SEG2)==1) stat[i]=3;
					if(ptx[i][a]<0) ptx[i][a]=0;
					if(ptx[i][a]>=128) ptx[i][a]=127;
					if(pty[i][a]>56) pty[i][a]=56;}
				  else	{ptx[i][a]=ptx[i][(a-1+TMAX)%TMAX];
						pty[i][a]=pty[i][(a-1+TMAX)%TMAX];
						k++;}
				if (k==FMAX) stop=1;
				}
			for(i=0;i<FMAX;i++)
				{for (j=b;j<b+TMAX-1;j++)
					setPix(ptx[i][j%TMAX],56-pty[i][j%TMAX],SEG1,0);
				setPix(ptx[i][a],56-pty[i][a],SEG1,1);}
			k=0;
			for(i=0;i<FMAX;i++)  if (stat[i]!=2)	{explx[k]=ptx[i][a];
											exply[k]=pty[i][a];
											k++;}
			if (k!=0) {explMulti(explx,exply,k,armesRay[asel[p]]);
					for(i=0;i<k;i++) killTanks(explx[i],exply[i],armesRay[asel[p]],p);}
			}
		}

/* Digger - Sandhog */
	if (asel[p]==11 || asel[p]==12)
		{char mode=(asel[p]==11?0:1);
		shoot(tankx[p],tanky[p],angle[p],power[p],0);
		if (stop!=2)
			{int x=om[0],y=om[1];
			int incx[]={-1, 0, 1, 1, 1, 0,-1,-1};
			int incy[]={ 1, 1, 1, 0,-1,-1,-1, 0};
			int explx[10],exply[10];
			if (stop==3) y=sol[x];
			if (mode==1) j=randomm(8);
			if (y>0)
				{k=0;
				for (i=0;i<armesRay[asel[p]];i++)
					{if (mode==0)	j=randomm(10);
						else {if (randomm(3)==0) j=randomm(8);}
					x+=incx[j];
					y+=incy[j];
					if (x<0 || x>=128 || y<=0 || y>sol[x])
						{x-=incx[j];
						y-=incy[j];}
					else	setPix(x,56-y,SEG1,0);
					if (mode==1 && i%100==0) {explx[k]=x;exply[k]=y;k++;
										fillCircle(x,y,2,0,SEG1);}
					}
				delay(1000);
				if (mode==1) for(i=0;i<k;i++) killTanks(explx[i],exply[i],3,p);}
			}
		}
  
choix=CHECKTANKS;return;
}
void checktanks()
{

 earthfall();

	for(i=0;i<NP;i++) if (bat[i]>=0) fallTank(i);

	for(i=0;i<NP;i++) if (bat[i]==0)	{bat[i]=-1;
								for (j=0;j<5;j++)
									{drawTank(i,SEG1,1,0);
									delay(100);
									drawTank(i,SEG1,0,0);
									delay(200);}
								explosion(tankx[i],tanky[i],5);
								killTanks(tankx[i],tanky[i],5,p);
								choix=CHECKTANKS;return;}
choix=ENDTURN;return;
}

void endturn()
{
 j=0;
	for(i=0;i<NP;i++) if (bat[i]>0) j++; else drawTank(i,SEG1,0,0);
	if (j>=2)
		{do {q=(q+1)%NP;} while(bat[ordre[NP-q-1]]==-1);
		choix=PLAY;return;}

	for (i=0;i<NP;i++)
		if (bat[i]>0) addFric(i,500);

	for(i=0;i<NP-1;i++)
		for(j=i+1;j<NP;j++)
			if(credits[ordre[j]]>credits[ordre[i]])
				{k=ordre[i];
				ordre[i]=ordre[j];
				ordre[j]=k;}

	mcur--;
	if (mcur==0) clrscr();
	dispScores();
	waitkey();
	if (mcur>0) {choix=NEWROUND;return;}
	choix=MENU; return;

}
void ennd()
{
 clrscr();
	drawString(1,1,"SCORCH   BY DUOBAB",SEG1);
	drawString(1,20,"END...REMADE WITH",SEG1);
	drawString(1,40,"DRXE BY VEB...",SEG1);

	invTxtLine(0);
	delay(5000);
	exit(1);

}


			/*******************************************************/
			/*				fonction principale				*/ 
			/*******************************************************/
//c+Timerlib+mainl+goto,mainl,mainl -FARCALLTRANSLATION -DETAILEDMAP

main()
	{

	srand(get_time(3));
	clrscr();
	drawString(2,2,"LOADING SCORCH...",SEG1);
	for(i=0;i<PMAX;i++)
		{noms[i][0]='T';
		noms[i][1]='A';
		noms[i][2]='N';
		noms[i][3]='K';
		noms[i][4]=(i+1)+48;}
	for(i=0;i<AMAX;i++) saveListePics(i);

	
        menu();
        while (1==1)
        {
         if (choix==NEWROUND) newround();
         if (choix==PLAY) play();
         if (choix==CHECKTANKS) checktanks();
         if (choix==ENDTURN) endturn();
         if (choix==MENU) menu();



        }


	}
